#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Tool to recompile bootmgr.exe to bootmgr ready for booting.
; Sample by Joakim Schicht
; 20.05.12
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <winapi.au3>
#Include <WinAPIEx.au3>
Global $SigXH = "424d5848"
Global $SigCI = "424d4349"

$Form = GUICreate("BOOTMGR compiler - by Joakim Schicht", 350, 160, -1, -1)
$Label1 = GUICtrlCreateLabel("Select library to compress with and method:", 20, 10, 250, 17)

Global $checkMSCompression = GUICtrlCreateCheckbox("Use MSCompression.dll", 20, 40, 140, 20)
Global $checkNtdll = GUICtrlCreateCheckbox("Use ntdll.dll", 20, 70, 100, 20)

If @OSArch = "X86" Then
	GUICtrlSetState($checkMSCompression, $GUI_UNCHECKED)
	GUICtrlSetState($checkNtdll, $GUI_CHECKED)
Else
	GUICtrlSetState($checkMSCompression, $GUI_CHECKED)
	GUICtrlSetState($checkNtdll, $GUI_UNCHECKED)
EndIf

Global $checkLZNT1 = GUICtrlCreateCheckbox("Use LZNT1", 220, 40, 140, 20)
GUICtrlSetState($checkLZNT1, $GUI_UNCHECKED)
Global $checkXpressHuffman = GUICtrlCreateCheckbox("Use XpressHuff", 220, 70, 100, 20)
GUICtrlSetState($checkXpressHuffman, $GUI_CHECKED)

$Button1 = GUICtrlCreateButton("Open bootmgr.exe", 140, 110, 100, 25, $WS_GROUP)
GUISetState(@SW_SHOW)

While 1
$nMsg = GUIGetMsg()

Select
	Case $nMsg = $Button1
		_Main()

	Case $nMsg = $GUI_EVENT_CLOSE
		Exit

EndSelect
WEnd

Func _Main()
Local  $CompressedChunk, $CompressionFormatAndEngine
If GUICtrlRead($checkMSCompression) = GUICtrlRead($checkNtdll) Then
	MsgBox(0, "Error", "You must select 1 library")
	Return
EndIf
If GUICtrlRead($checkLZNT1) = GUICtrlRead($checkXpressHuffman) Then
	MsgBox(0, "Error", "You must select 1 compression method")
	Return
EndIf
Select
	Case GUICtrlRead($checkNtdll) = 1 AND GUICtrlRead($checkLZNT1) = 1
		$CompressionFormatAndEngine = 258
	Case GUICtrlRead($checkNtdll) = 1 AND GUICtrlRead($checkXpressHuffman) = 1
		$CompressionFormatAndEngine = 260
	Case GUICtrlRead($checkMSCompression) = 1 AND GUICtrlRead($checkXpressHuffman) = 1
		$CompressionFormatAndEngine = 4
	Case GUICtrlRead($checkMSCompression) = 1 AND GUICtrlRead($checkLZNT1) = 1
		$CompressionFormatAndEngine = 2
EndSelect
;If GUICtrlRead($checkNtdll) = 1 Then
;	$CompressionFormatAndEngine = 260
;ElseIf GUICtrlRead($checkMSCompression) = 1 Then
;	$CompressionFormatAndEngine = 4
;EndIf
$UncompressedFile = FileOpenDialog("Select the Uncompressed file (bootmgr.exe):",@ScriptDir,"All (*.*)")
If @error Then Exit
$FilePath = $UncompressedFile
FileClose($UncompressedFile)
; Do some validation of the executable
_TestPE($FilePath)
$UncompressedSize = FileGetSize($UncompressedFile)
ConsoleWrite("Uncompressed file size: " & $UncompressedSize & @CRLF)
$oUncompressedFile = FileOpen($UncompressedFile,16)
$rUncompressedFile = FileRead($oUncompressedFile)
$UncompressedSize = SwapEndian($UncompressedSize)
ConsoleWrite("Uncompressed file size: " & $UncompressedSize & @CRLF)
If GUICtrlRead($checkNtdll) = 1 Then
	$CompressedChunk = _RtlCompression($CompressionFormatAndEngine,$rUncompressedFile)
ElseIf GUICtrlRead($checkMSCompression) = 1 Then
	$CompressedChunk = _MSCompression($CompressionFormatAndEngine,$rUncompressedFile)
EndIf
If @error Then
	MsgBox(0,"Error with compression",$CompressedChunk)
;	FileClose($oUncompressedFile)
	Exit
EndIf
FileClose($oUncompressedFile)

$CompressedSize = BinaryLen($CompressedChunk)
ConsoleWrite("Compressed file size: " & $CompressedSize & @CRLF)
$CompressedFileStruct = DllStructCreate("align 1;byte["&$CompressedSize&"]")
DllStructSetData($CompressedFileStruct,1,$CompressedChunk)
$CompressedSize = SwapEndian($CompressedSize)
ConsoleWrite("Compressed file size: " & $CompressedSize & @CRLF)

;Create 16-bit stub
If GUICtrlRead($checkXpressHuffman) = 1 Then
	$inFile = @ScriptDir&"\BMXH.stub"
ElseIf GUICtrlRead($checkLZNT1) = 1 Then
	$inFile = @ScriptDir&"\BMCI.stub"
EndIf
If NOT FileExists($inFile) Then
	If GUICtrlRead($checkXpressHuffman) = 1 Then
		$hResource = _WinAPI_FindResource(0, 10, '#3')
	ElseIf GUICtrlRead($checkLZNT1) = 1 Then
		$hResource = _WinAPI_FindResource(0, 10, '#4')
	EndIf
	ConsoleWrite("Resource handle = " & $hResource & @CRLF)
	If $hResource = 0 Then
		ConsoleWrite("Error: Resource not found" & @CRLF)
		Return SetError(1, 0, 0)
		Return
	EndIf
	$iSize = _WinAPI_SizeOfResource(0, $hResource)
	ConsoleWrite("Resource size = " & $iSize & " bytes" & @CRLF)
	$hData = _WinAPI_LoadResource(0, $hResource)
	ConsoleWrite("$hData = " & $hData & @CRLF)
	$pData = _WinAPI_LockResource($hData)
	ConsoleWrite("$pData = " & $pData & @CRLF)
	$tBuffer0=DllStructCreate('align 1;byte STUB['&$iSize&']', $pData)
	$Stub = DllStructGetData($tBuffer0,'STUB')
	If $Stub = "" Then
		ConsoleWrite("DllStructGetData failed $Stub" & @CRLF)
		MsgBox(0, "Error", "DllStructGetData failed $Stub")
		Exit
	EndIf
	$StubStruct = DllStructCreate("align 1;byte["&$iSize&"]")
	DllStructSetData($StubStruct,1,$Stub)
Else
	$StubSize = FileGetSize($inFile)
	$tFile = FileOpen($inFile,16)
	$rFile = FileRead($tFile)
	$StubStruct = DllStructCreate("align 1;byte["&$StubSize&"]")
	DllStructSetData($StubStruct,1,$rFile)
	FileClose($tFile)
EndIf

;Create 16 byte section
If GUICtrlRead($checkXpressHuffman) = 1 Then
	$Sig = $SigXH
ElseIf GUICtrlRead($checkLZNT1) = 1 Then
	$Sig = $SigCI
EndIf
$NewSection = $Sig & $CompressedSize & $UncompressedSize & "10200000"
$NewSectionStruct = DllStructCreate("byte[16]")
DllStructSetData($NewSectionStruct,1,"0x" & $NewSection)
;Create TinyPE
$TinyPEStruct = DllStructCreate("align 1;byte[8192]") ; These bytes are not evaluated, so we don't bother and put 00's

Local $nBytes
$oOutFile = FileSaveDialog("Choose a name.", @ScriptDir, "All (*.*)", 16, "bootmgr_mod")
If @error Then
	Exit
EndIf

If FileExists($oOutFile) Then
	FileDelete($oOutFile)
EndIf
$hFile = _WinAPI_CreateFile("\\.\" & $oOutFile,3,6,7)
ConsoleWrite("CreateFile: " & _WinAPI_GetLastErrorMessage() & @CRLF)
_WinAPI_WriteFile($hFile, DllStructGetPtr($StubStruct), DllStructGetSize($StubStruct), $nBytes)
ConsoleWrite("WriteFile: " & _WinAPI_GetLastErrorMessage() & @CRLF)
_WinAPI_FlushFileBuffers($hFile)
_WinAPI_SetFilePointer($hFile, DllStructGetSize($StubStruct))

_WinAPI_WriteFile($hFile, DllStructGetPtr($NewSectionStruct), DllStructGetSize($NewSectionStruct), $nBytes)
_WinAPI_FlushFileBuffers($hFile)
_WinAPI_SetFilePointer($hFile, DllStructGetSize($StubStruct)+DllStructGetSize($NewSectionStruct))

_WinAPI_WriteFile($hFile, DllStructGetPtr($TinyPEStruct), DllStructGetSize($TinyPEStruct), $nBytes)
_WinAPI_FlushFileBuffers($hFile)
_WinAPI_SetFilePointer($hFile, DllStructGetSize($StubStruct)+DllStructGetSize($NewSectionStruct)+DllStructGetSize($TinyPEStruct))

_WinAPI_WriteFile($hFile, DllStructGetPtr($CompressedFileStruct), DllStructGetSize($CompressedFileStruct), $nBytes)
_WinAPI_FlushFileBuffers($hFile)
_WinAPI_CloseHandle($hFile)
Return
EndFunc

Func SwapEndian($Data)
    Return StringLeft(Hex(Binary($Data),4),8)
EndFunc

Func _MSCompression($iCompressionFormatAndEngine,$vInput)

Local $tInput = DllStructCreate("byte[" & BinaryLen($vInput) & "]")
DllStructSetData($tInput, 1, $vInput)
Local $tBuffer = DllStructCreate("byte[" & DllStructGetSize($tInput) & "]")
If NOT FileExists(@ScriptDir&"\MSCompression.dll") Then
	MsgBox(0,"Error", "MSCompression.dll not found in current directory")
	Exit
EndIf
Local $dll = DllOpen(@ScriptDir & "\MSCompression.dll")

Local $aCall = DllCall($dll, "int", "compress", _
        "dword", $iCompressionFormatAndEngine, _
        "ptr", DllStructGetPtr($tInput), _
        "dword", DllStructGetSize($tInput), _
        "ptr", DllStructGetPtr($tBuffer), _
        "dword*", 0)
If $aCall[0] = 0 Then
	Return SetError(1, 0, "Something went wrong")
EndIf
;If _WinAPI_GetLastError() <> 0 OR $aCall[0] = 0 Then
;	Return SetError(1, 0, _WinAPI_GetLastErrorMessage())
;EndIf
Local $tBuffer = DllStructCreate("byte[" & $aCall[0] & "]")
Local $bCall = DllCall($dll, "int", "compress", _
        "dword", $iCompressionFormatAndEngine, _
        "ptr", DllStructGetPtr($tInput), _
        "dword", DllStructGetSize($tInput), _
        "ptr", DllStructGetPtr($tBuffer), _
        "dword", DllStructGetSize($tBuffer))

If $bCall[0] = 0 Then
	Return SetError(1, 0, "Something went wrong")
;If _WinAPI_GetLastError() <> 0 Then
;	Return SetError(1, 0, _WinAPI_GetLastErrorMessage())
Else
	Return DllStructGetData($tBuffer,1)
EndIf
EndFunc

Func _RtlCompression($iCompressionFormatAndEngine, $vInput)
	Local $ErrorMessage, $dll
    Local $tInput = DllStructCreate("byte[" & BinaryLen($vInput) & "]")
    DllStructSetData($tInput, 1, $vInput)
	If @OSBuild < 7955 AND GUICtrlRead($checkLZNT1) <> 1 Then
		If NOT FileExists(@ScriptDir&"\ntdll.dll") Then
			MsgBox(0,"Error", "ntdll.dll not found in current directory")
			Exit
		EndIf
		$dll = DllOpen(@ScriptDir&"\ntdll.dll")
	Else
		$dll = "ntdll.dll"
	EndIf
;	ConsoleWrite("$dll: " & $dll & @CRLF)
    Local $a_Call = DllCall($dll, "int", "RtlGetCompressionWorkSpaceSize", _
            "ushort", $iCompressionFormatAndEngine, _
            "ulong*", 0, _
            "ulong*", 0)

	If $a_Call[0] >= 0 AND $a_Call[0] <= 0x7FFFFFFF Then
		ConsoleWrite("RtlGetCompressionWorkSpaceSize success with status code: "  & $a_Call[0] & @CRLF)
	Else
		$ErrorMessage = _StatusMessage($a_Call[0])
		ConsoleWrite("Error: RtlGetCompressionWorkSpaceSize failed with status code: " & $ErrorMessage & @CRLF)
		Return SetError(1, 0, "RtlGetCompressionWorkSpaceSize: " & $ErrorMessage)
	EndIf

    Local $tWorkSpace = DllStructCreate("byte[" & $a_Call[2] & "]")
    Local $tBuffer = DllStructCreate("byte[" & 2 * DllStructGetSize($tInput) & "]")

    Local $a_Call = DllCall($dll, "int", "RtlCompressBuffer", _
            "ushort", $iCompressionFormatAndEngine, _
            "ptr", DllStructGetPtr($tInput), _
            "dword", DllStructGetSize($tInput), _
            "ptr", DllStructGetPtr($tBuffer), _
            "dword", DllStructGetSize($tBuffer), _
            "dword", 4096, _
            "dword*", 0, _
            "ptr", DllStructGetPtr($tWorkSpace))
	DllClose($dll)
	If $a_Call[0] >= 0 AND $a_Call[0] <= 0x7FFFFFFF Then
		ConsoleWrite("RtlCompressBuffer success with status code: "  & $a_Call[0] & @CRLF)
	Else
		$ErrorMessage = _StatusMessage($a_Call[0])
		ConsoleWrite("Error: RtlCompressBuffer failed with status code: " & $ErrorMessage & @CRLF)
		Return SetError(1, 0, "RtlCompressBuffer: " & $ErrorMessage)
	EndIf

    Local $tOutput = DllStructCreate("byte[" & $a_Call[7] & "]", DllStructGetPtr($tBuffer))

    Return SetError(0, 0, DllStructGetData($tOutput, 1))

EndFunc

Func _StatusMessage($StatusMessage)
Local $ret = ""
Select
	Case $StatusMessage = 0
		$ret = "SUCCESS"
	Case $StatusMessage = -1073741811
		$ret = "INVALID_PARAMETER"
	Case $StatusMessage = -1073741789
		$ret = "BUFFER_TOO_SMALL"
	Case $StatusMessage = -1073741637
		$ret = "NOT_SUPPORTED"
	Case $StatusMessage = -1073741545
		$ret = "BUFFER_ALL_ZEROS"
	Case $StatusMessage = -1073741246
		$ret = "BAD_COMPRESSION_BUFFER"
	Case $StatusMessage = -1073741217
		$ret = "UNSUPPORTED_COMPRESSION"
	Case Else
		$ret = "UNKNOWN"
EndSelect
Return $ret
EndFunc

Func _TestPE($PEFile)
Local $hFile = _WinAPI_CreateFile("\\.\" & $PEFile,2,6,7)
If $hFile = 0 Then
	ConsoleWrite("CreateFile function function failed on executable" & @CRLF)
	Return
EndIf
$DosHeader = _DosHeader($hFile)
If $DosHeader[0] <> "MZ" Then
	ConsoleWrite("TestPE: Error - This is not an executable. First 2 bytes returned: " & $DosHeader[0] & " Choose another file!." & @CRLF)
	_WinAPI_CloseHandle($hFile)
	Return
EndIf
$PEstart = $DosHeader[17]
$FileHeader = _FileHeader($hFile,$PEstart)
$SizeOfOptionalHeader = $FileHeader[6]
$OHOffset = $PEstart+24
$OptionalHeader = _OptionalHeader($hFile,$OHOffset,$SizeOfOptionalHeader)
$Magic = $OptionalHeader[0]
$Arch = ""
If $Magic = 523 Then $Arch = "PE64"
If $Magic = 267 Then $Arch = "PE32"
;If $Magic = 263 Then $Arch = "ROM"
ConsoleWrite("$Arch: " & $Arch & @CRLF)
If $Magic <> 267 AND $Magic <> 523 Then
	ConsoleWrite("TestPE: Error - PE file is neither of PE32 or PE64. Choose another one!." & @CRLF)
	_WinAPI_CloseHandle($hFile)
	Return
EndIf

$FileAlignment = $OptionalHeader[11]
$ChecksumPosition = $PEstart+88
$CalcChecksum = _MapFileAndCheckSum($PEFile)
If $CalcChecksum[0] <> 0 Then
;	MsgBox(0,"Warning","Error occurred when calculating checksum of PE, but signature seems OK")
	ConsoleWrite("TestPE: Warning - Error occurred when calculating checksum of PE" & @CRLF)
	_WinAPI_CloseHandle($hFile)
	Return
EndIf

If Hex($CalcChecksum[1]) <> Hex($CalcChecksum[2]) Then
	$msgbox = MsgBox( 4, "Warning", "Checksum in PE was incorrect. Click Yes to update checksum.")
	ConsoleWrite("TestPE: Checksum in PE was incorrect" & @CRLF)
	If $msgbox = 6 Then
		_FixChecksum($hFile,$ChecksumPosition,$CalcChecksum[2])
		_WinAPI_CloseHandle($hFile)
	EndIf
EndIf
_WinAPI_CloseHandle($hFile)
EndFunc

Func _DosHeader($hFile)
	ConsoleWrite("DosHeader: Attempt of decoding.." & @CRLF)
	$pPointer = $hFile
	Local $DOS_HEADER[18], $nBytes
	_WinAPI_SetFilePointer($hFile, 0)
;	Local $fSize = 63
	Local $fSize = 64
	$tBuffer = 0
	$tBuffer = DllStructCreate("byte[" & $fSize & "]")
	$read = 0
	$read = _WinAPI_ReadFile($hFile, DllStructGetPtr($tBuffer), $fSize, $nBytes)
	If $read = 0 then
;		MsgBox(0,"Error", "ReadFile failed")
		ConsoleWrite("DosHeader: Error ReadFile failed" & @CRLF)
		Return
	EndIf
	$raw = 0
	$raw = DllStructGetData($tBuffer,1)

	Local $tIMAGE_DOS_HEADER = DllStructCreate("char Magic[2];" & _
			"ushort BytesOnLastPage;" & _
			"ushort Pages;" & _
			"ushort Relocations;" & _
			"ushort SizeofHeader;" & _
			"ushort MinimumExtra;" & _
			"ushort MaximumExtra;" & _
			"ushort SS;" & _
			"ushort SP;" & _
			"ushort Checksum;" & _
			"ushort IP;" & _
			"ushort CS;" & _
			"ushort Relocation;" & _
			"ushort Overlay;" & _
			"char Reserved[8];" & _
			"ushort OEMIdentifier;" & _
			"ushort OEMInformation;" & _
			"char Reserved2[20];" & _
			"dword AddressOfNewExeHeader", _
			DllStructGetPtr($tBuffer))

	$DOS_HEADER[0] = DllStructGetData($tIMAGE_DOS_HEADER, "Magic")
	$DOS_HEADER[1] = DllStructGetData($tIMAGE_DOS_HEADER, "BytesOnLastPage")
	$DOS_HEADER[2] = DllStructGetData($tIMAGE_DOS_HEADER, "Pages")
	$DOS_HEADER[3] = DllStructGetData($tIMAGE_DOS_HEADER, "Relocations")
	$DOS_HEADER[4] = DllStructGetData($tIMAGE_DOS_HEADER, "SizeofHeader")
	$DOS_HEADER[5] = DllStructGetData($tIMAGE_DOS_HEADER, "MinimumExtra")
	$DOS_HEADER[6] = DllStructGetData($tIMAGE_DOS_HEADER, "SS")
	$DOS_HEADER[7] = DllStructGetData($tIMAGE_DOS_HEADER, "SP")
	$DOS_HEADER[8] = DllStructGetData($tIMAGE_DOS_HEADER, "Checksum")
	$DOS_HEADER[9] = DllStructGetData($tIMAGE_DOS_HEADER, "IP")
	$DOS_HEADER[10] = DllStructGetData($tIMAGE_DOS_HEADER, "CS")
	$DOS_HEADER[11] = DllStructGetData($tIMAGE_DOS_HEADER, "Relocation")
	$DOS_HEADER[12] = DllStructGetData($tIMAGE_DOS_HEADER, "Overlay")
	$DOS_HEADER[13] = DllStructGetData($tIMAGE_DOS_HEADER, "Reserved")
	$DOS_HEADER[14] = DllStructGetData($tIMAGE_DOS_HEADER, "OEMIdentifier")
	$DOS_HEADER[15] = DllStructGetData($tIMAGE_DOS_HEADER, "OEMInformation")
	$DOS_HEADER[16] = DllStructGetData($tIMAGE_DOS_HEADER, "Reserved2")
	$DOS_HEADER[17] = DllStructGetData($tIMAGE_DOS_HEADER, "AddressOfNewExeHeader")
	ConsoleWrite("DosHeader: Magic = " & $DOS_HEADER[0] & @CRLF)
	ConsoleWrite("DosHeader: AddressOfNewExeHeader (PE start) = 0x" & Hex($DOS_HEADER[17],8) & @CRLF)
	Return $DOS_HEADER
EndFunc

Func _FileHeader($hFile,$AddressOfNewExeHeader)
	ConsoleWrite("FileHeader: Attempt of decoding.." & @CRLF)
	Local $FILE_HEADER[8], $nBytes
	ConsoleWrite("$AddressOfNewExeHeader: " & $AddressOfNewExeHeader & @CRLF)
	_WinAPI_SetFilePointer($hFile, $AddressOfNewExeHeader)
;	Local $fSize = 24
	Local $fSize = 25
	$tBuffer = 0
	$tBuffer = DllStructCreate("byte[" & $fSize & "]")
	$read = 0
	$read = _WinAPI_ReadFile($hFile, DllStructGetPtr($tBuffer), $fSize, $nBytes)
	If $read = 0 then
;		MsgBox(0,"Error", "ReadFile failed")
		ConsoleWrite("FileHeader: Error ReadFile failed" & @CRLF)
		Return
	EndIf
	$raw = 0
	$raw = DllStructGetData($tBuffer,1)

	Local $tIMAGE_FILE_HEADER = DllStructCreate("dword Signature;" & _
		"ushort Machine;" & _
		"ushort NumberOfSections;" & _
		"dword TimeDateStamp;" & _
		"dword PointerToSymbolTable;" & _
		"dword NumberOfSymbols;" & _
		"ushort SizeOfOptionalHeader;" & _
		"ushort Characteristics", _
		DllStructGetPtr($tBuffer))

	$FILE_HEADER[0] = DllStructGetData($tIMAGE_FILE_HEADER, "Signature")
	$FILE_HEADER[1] = DllStructGetData($tIMAGE_FILE_HEADER, "Machine")
	$FILE_HEADER[2] = DllStructGetData($tIMAGE_FILE_HEADER, "NumberOfSections")
	$FILE_HEADER[3] = DllStructGetData($tIMAGE_FILE_HEADER, "TimeDateStamp")
	$FILE_HEADER[4] = DllStructGetData($tIMAGE_FILE_HEADER, "PointerToSymbolTable")
	$FILE_HEADER[5] = DllStructGetData($tIMAGE_FILE_HEADER, "NumberOfSymbols")
	$FILE_HEADER[6] = DllStructGetData($tIMAGE_FILE_HEADER, "SizeOfOptionalHeader")
	$FILE_HEADER[7] = DllStructGetData($tIMAGE_FILE_HEADER, "Characteristics")
	ConsoleWrite("FileHeader: Signature = 0x" & Hex($FILE_HEADER[0],8) & @CRLF)
	ConsoleWrite("FileHeader: Machine = 0x" & Hex($FILE_HEADER[1],4) & @CRLF)
	ConsoleWrite("FileHeader: NumberOfSections = 0x" & Hex($FILE_HEADER[2],4) & @CRLF)
	ConsoleWrite("FileHeader: SizeOfOptionalHeader = 0x" & Hex($FILE_HEADER[6],4) & @CRLF)
	Return $FILE_HEADER
EndFunc

;Optional Header is slightly different on PE64, but works here on this basic usage.
Func _OptionalHeader($hFile,$OHOffset,$SizeOfOptionalHeader)
	ConsoleWrite("OptionalHeader: Attempt of decoding.." & @CRLF)
	Local $OPTIONAL_HEADER[30], $nBytes
	_WinAPI_SetFilePointer($hFile, $OHOffset)
	Local $fSize = 92
	$tBuffer = 0
	$tBuffer = DllStructCreate("byte[" & $fSize & "]")
	$read = 0
	$read = _WinAPI_ReadFile($hFile, DllStructGetPtr($tBuffer), $fSize, $nBytes)
	If $read = 0 then
;		MsgBox(0,"Error", "ReadFile failed")
		ConsoleWrite("OptionalHeader: Error ReadFile failed" & @CRLF)
		Return
	EndIf
	$raw = 0
	$raw = DllStructGetData($tBuffer,1)

	Local $tIMAGE_OPTIONAL_HEADER = DllStructCreate("ushort Magic;" & _
			"ubyte MajorLinkerVersion;" & _
			"ubyte MinorLinkerVersion;" & _
			"dword SizeOfCode;" & _
			"dword SizeOfInitializedData;" & _
			"dword SizeOfUninitializedData;" & _
			"dword AddressOfEntryPoint;" & _
			"dword BaseOfCode;" & _
			"dword BaseOfData;" & _
			"dword ImageBase;" & _
			"dword SectionAlignment;" & _
			"dword FileAlignment;" & _
			"ushort MajorOperatingSystemVersion;" & _
			"ushort MinorOperatingSystemVersion;" & _
			"ushort MajorImageVersion;" & _
			"ushort MinorImageVersion;" & _
			"ushort MajorSubsystemVersion;" & _
			"ushort MinorSubsystemVersion;" & _
			"dword Win32VersionValue;" & _
			"dword SizeOfImage;" & _
			"dword SizeOfHeaders;" & _
			"dword CheckSum;" & _
			"ushort Subsystem;" & _
			"ushort DllCharacteristics;" & _
			"dword SizeOfStackReserve;" & _
			"dword SizeOfStackCommit;" & _
			"dword SizeOfHeapReserve;" & _
			"dword SizeOfHeapCommit;" & _
			"dword LoaderFlags;" & _
			"dword NumberOfRvaAndSizes", _
			DllStructGetPtr($tBuffer))

	$OPTIONAL_HEADER[0] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "Magic")
	$OPTIONAL_HEADER[1] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MajorLinkerVersion")
	$OPTIONAL_HEADER[2] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MinorLinkerVersion")
	$OPTIONAL_HEADER[3] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfCode")
	$OPTIONAL_HEADER[4] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfInitializedData")
	$OPTIONAL_HEADER[5] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfUninitializedData")
	$OPTIONAL_HEADER[6] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "AddressOfEntryPoint")
	$OPTIONAL_HEADER[7] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "BaseOfCode")
	$OPTIONAL_HEADER[8] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "BaseOfData")
	$OPTIONAL_HEADER[9] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "ImageBase")
	$OPTIONAL_HEADER[10] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SectionAlignment")
	$OPTIONAL_HEADER[11] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "FileAlignment")
	$OPTIONAL_HEADER[12] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MajorOperatingSystemVersion")
	$OPTIONAL_HEADER[13] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MinorOperatingSystemVersion")
	$OPTIONAL_HEADER[14] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MajorImageVersion")
	$OPTIONAL_HEADER[15] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MinorImageVersion")
	$OPTIONAL_HEADER[16] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MajorSubsystemVersion")
	$OPTIONAL_HEADER[17] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "MinorSubsystemVersion")
	$OPTIONAL_HEADER[18] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "Win32VersionValue")
	$OPTIONAL_HEADER[19] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfImage")
	$OPTIONAL_HEADER[20] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfHeaders")
	$OPTIONAL_HEADER[21] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "CheckSum")
	$OPTIONAL_HEADER[22] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "Subsystem")
	$OPTIONAL_HEADER[23] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "DllCharacteristics")
	$OPTIONAL_HEADER[24] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfStackReserve")
	$OPTIONAL_HEADER[25] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfStackCommit")
	$OPTIONAL_HEADER[26] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfHeapReserve")
	$OPTIONAL_HEADER[27] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "SizeOfHeapCommit")
	$OPTIONAL_HEADER[28] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "LoaderFlags")
	$OPTIONAL_HEADER[29] = DllStructGetData($tIMAGE_OPTIONAL_HEADER, "NumberOfRvaAndSizes")
	ConsoleWrite("OptionalHeader: Magic = 0x" & Hex($OPTIONAL_HEADER[0],4) & @CRLF)
	ConsoleWrite("OptionalHeader: FileAlignment = 0x" & Hex($OPTIONAL_HEADER[11],8) & @CRLF)
	ConsoleWrite("OptionalHeader: SizeOfImage = 0x" & Hex($OPTIONAL_HEADER[19],8) & @CRLF)
	ConsoleWrite("OptionalHeader: SizeOfHeaders = 0x" & Hex($OPTIONAL_HEADER[20],8) & @CRLF)
	Return $OPTIONAL_HEADER
EndFunc

Func _MapFileAndCheckSum($PEfile)
    Local $aResult[3]
	Local $outHeaderSum = DLLStructCreate("dword")
	Local $outCheckSum = DLLStructCreate("dword")
    $aResult = DllCall("imagehlp.dll", "long" , "MapFileAndCheckSum" , "str" ,$PEfile , "ptr" ,DllStructGetPtr($outHeaderSum), "ptr" ,DllStructGetPtr($outCheckSum))
;    If @error Then Return SetError(@error, 0, 0)
    If $aResult[0] <> 0 Then
;		MsgBox( 0, "Error Occured", "MapFileAndCheckSum returned: " & $aResult[0])
		ConsoleWrite("MapFileAndCheckSum: Error code: " & $aResult[0] & @CRLF)
		Return SetError(@error, 0, 0)
	EndIf
	$aResult[1] = DllStructGetData($outHeaderSum, 1)
    $aResult[2] = DllStructGetData($outCheckSum,1)
	ConsoleWrite("MapFileAndCheckSum: Checksum present in header = 0x" & Hex($aResult[1],8) & @CRLF)
	ConsoleWrite("MapFileAndCheckSum: Checksum calculated = 0x" & Hex($aResult[2],8) & @CRLF)
    Return $aResult
EndFunc

Func _FixChecksum($input,$ChecksumPosition,$CorrectChecksum)
	ConsoleWrite("FixChecksum: Writing updated checksum.." & @CRLF)
	Local $nBytes, $tBuffer
	$CorrectChecksum = Hex($CorrectChecksum,8)
	$CorrectChecksum = "0x" & StringMid($CorrectChecksum,7,2) & StringMid($CorrectChecksum,5,2) & StringMid($CorrectChecksum,3,2) & StringMid($CorrectChecksum,1,2)
	_WinAPI_SetFilePointer($input, $ChecksumPosition)
	$tBuffer = 0
	$tBuffer = DllStructCreate("byte[" & 4 & "]")
	DllStructSetData($tBuffer,1,$CorrectChecksum)
	_WinAPI_WriteFile($input, DllStructGetPtr($tBuffer), 4, $nBytes)
EndFunc